import { createStackNavigator } from 'react-navigation-stack';
import { createAppContainer } from 'react-navigation';
import WelcomeScreen from './WelcomeScreen.js';
import Listas from './Listas.js';
import Productos from './Productos.js';
import InputP from './ProductInput.js';
import InputL from './ListInput.js';

const screens = {

    Welcome: {
        screen: WelcomeScreen
    },

    Lists: {
        screen: Listas
    },

    Products: {
        screen: Productos
    },

    NewProduct: {
        screen: InputP
    },

    NewList: {
        screen: InputL
    },

}

const HomeStack = createStackNavigator(screens);

export default createAppContainer(HomeStack);